var dataDomain = ""

function setDataDomain(domain) {
    dataDomain = domain
}
//var layer = L.tileLayer('http://mt1.google.cn/vt/lyrs=y@207000000&hl=zh-CN&gl=CN&src=app&x={x}&y={y}&z={z}', {
//    minZoom: 1,
//    maxZoom: 18,
//    zIndex: 1000,
//});
var layer = L.tileLayer('https://t{s}.tianditu.gov.cn/DataServer?T=img_w&x={x}&y={y}&l={z}&tk=4f3b654bf06e2d571e24c9ee3791071d', {
    subdomains: ["0", "1", "2", "3", "4", "5", "6", "7"],
    maxZoom: 13,
    minZoom: 4,
    zIndex: 1000,
    // zoomOffset: 1
});
var layer1 = L.tileLayer('https://t{s}.tianditu.gov.cn/DataServer?T=cva_w&x={x}&y={y}&l={z}&tk=4f3b654bf06e2d571e24c9ee3791071d', {
    subdomains: ["0", "1", "2", "3", "4", "5", "6", "7"],
    maxZoom: 13,
    minZoom: 4,
    zIndex: 1000,
    // zoomOffset: 1
});
var corner1 = L.latLng(89, 3600),
    corner2 = L.latLng(-89, -3600),
    bounds = L.latLngBounds(corner1, corner2);
var map = L.map('map', {
    minZoom: 4,
    maxZoom: 18,
    attributionControl: false,
    maxBounds: bounds,
    center: [39.91583, 116.39085],
    zoom: 6,
    zoomControl: false
});

$.blockUI({
    message: "<div class=\"loading\">\n" +
        "            <div class=\"loading-box\">\n" +
        "                <i class=\"fade-item fade-item1\"></i>\n" +
        "                <i class=\"fade-item fade-item2\"></i>\n" +
        "                <i class=\"fade-item fade-item3\"></i>\n" +
        "                <i class=\"fade-item fade-item4\"></i>\n" +
        "                <i class=\"fade-item fade-item5\"></i>\n" +
        "                <i class=\"fade-item fade-item6\"></i>\n" +
        "                <i class=\"fade-item fade-item7\"></i>\n" +
        "                <i class=\"fade-item fade-item8\"></i>\n" +
        "                <i class=\"fade-item fade-item9\"></i>\n" +
        "                <i class=\"fade-item fade-item10\"></i>\n" +
        "                <i class=\"fade-item fade-item11\"></i>\n" +
        "                <i class=\"fade-item fade-item12\"></i>\n" +
        "            </div>\n" +
        "        </div>",
    css: {
        border: 'none',
        // padding: '15px',
        backgroundColor: 'none',
        left: '40%',
        // border:unset,
        // '-webkit-border-radius': '10px',
        // '-moz-border-radius': '10px',
        // opacity: .5,
        // color: '#fff'
    }
});

var velocityLayer;

layer.addTo(map);
layer1.addTo(map);
var bandsWindLayer;
var page = 0;
var layerList = {};
var beforPage = 0;
var step = 30;
var urlPrefix="";
var is3d=false;
var sshdata=[];
var λ0, φ0, Δλ, Δφ,grid;

$('.arrow').hide();
function init(domain,url,p,imgUrl){
    dataDomain = domain
    urlPrefix=url
    page=p
    if(url.indexOf('cmems3d')>0){
        is3d=true
        $('.hourly').html("盐度: &nbsp")
    }
    layerList = {};
}
function load(url,callback) {
    const xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'arraybuffer';
    xhr.onload = () => {
        const data = new Uint8Array(xhr.response || xhr.mozResponseArrayBuffer);

        let imgData = pako.inflate(new Uint8Array(data));

        let ret = { uo: [], vo: [] };
        let i = 0;
        while (i < imgData.length) {
            let b1 = imgData[i] << 8;
            i++;
            let b2 = imgData[i] ;
            i++;

            ret.uo.push((b1+b2)>0?(b1 + b2-32767)*0.000610370188951492:0);
            let b3 = imgData[i] << 8;
            i++;
            let b4 = imgData[i] ;
            i++;
            ret.vo.push((b3+b4)>0?(b3 + b4-32767)*0.000610370188951492:0)
        }
        return callback(ret)
    };

    return xhr.send(null);
}
function getJSONssh(i, j, step) {
    return new Promise(resolve => {
        if(j<0)j=j+360;
        loadssh( urlPrefix.replace(/mercator/,'ssh').replace(/cmems3d/,'sst3d')+ page + '_' + (i - 0 + 90) + '_' + j + '.dat',  function (ret) {
            if(!layerList[page + '_' + i + '_' + j])layerList[page + '_' + i + '_' + j]={};
            layerList[page + '_' + i + '_' + j].sst = ret.sst;
            layerList[page + '_' + i + '_' + j].ssh = ret.ssh;

            resolve('resolved');

        })
    })
}
function loadssh(url,callback) {
    const xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'arraybuffer';
    xhr.onload = () => {
        const data = new Uint8Array(xhr.response || xhr.mozResponseArrayBuffer);

        let imgData = pako.inflate(new Uint8Array(data));

        let ret = { ssh: [], sst: [] };
        let i = 0;
        while (i < imgData.length) {
            let b1 = imgData[i] << 8;
            i++;
            let b2 = imgData[i] ;
            i++;
            ret.sst.push((b1+b2)>0?(b1 + b2-32767)*0.000732444226741791+21.0:0);

            let b3 = imgData[i] << 8;
            i++;
            let b4 = imgData[i] ;
            i++;
            if(is3d){
                ret.ssh.push((b3+b4)>0?(b3 + b4-32767)*0.00152592547237873-0.00152592547237873:0)
            }else{
                ret.ssh.push((b3+b4)>0?(b3 + b4-32767)*0.000305185094475746:0)
            }
        }
        return callback(ret)
    };

    return xhr.send(null);
}
function getJSON(i, j, step) {
    return new Promise(resolve => {
        if(j<0)j=j+360;
        load( urlPrefix+ page + '_' + (i - 0 + 90) + '_' + j + '.dat',  function (ret) {
            if(!layerList[page + '_' + i + '_' + j])layerList[page + '_' + i + '_' + j]={};

            layerList[page + '_' + i + '_' + j].uo = ret.uo;
            layerList[page + '_' + i + '_' + j].vo = ret.vo;

            resolve('resolved');

        })
    })
}
// 根据flutter的定位,设置地图的中心位置
function setCenter(lat, lon, zoom) {

    if (lat == undefined || lon == undefined) {
        lat = 39.91583
        lon = 116.39085
    }
    var latlng = L.latLng(lat, lon);
    if (zoom == undefined) {
        zoom = 6;
    }
    map.setView(latlng, 5)
}


// 根据URL计算地图边缘数据
function getMapBounds() {
    var latlng = map.getBounds();
    var zoom = map.getZoom();
    var lat1 = latlng['_southWest'].lat;
    var lat2 = latlng['_northEast'].lat;
    var lon1 = latlng['_southWest'].lng;
    var lon2 = latlng['_northEast'].lng;
    return [lat1, lat2, lon1, lon2, zoom];
}

// 设置地图的缩放级别
function setZoom(zoom) {
    map.setZoom(zoom)
}


function flutterGetData() {
    //    getData();
    return true;
}
//设置时间
function setTime(timeStr) {
    $('#date').html(timeStr)
}
// 设置地图数据
async function setMapData() {
//    if (Object.keys(layerList).length > 0 && beforPage != page) {
//        layerList = {};
//        beforPage = page;
//    }
        $.blockUI({
            message: "<div class=\"loading\">\n" +
                "            <div class=\"loading-box\">\n" +
                "                <i class=\"fade-item fade-item1\"></i>\n" +
                "                <i class=\"fade-item fade-item2\"></i>\n" +
                "                <i class=\"fade-item fade-item3\"></i>\n" +
                "                <i class=\"fade-item fade-item4\"></i>\n" +
                "                <i class=\"fade-item fade-item5\"></i>\n" +
                "                <i class=\"fade-item fade-item6\"></i>\n" +
                "                <i class=\"fade-item fade-item7\"></i>\n" +
                "                <i class=\"fade-item fade-item8\"></i>\n" +
                "                <i class=\"fade-item fade-item9\"></i>\n" +
                "                <i class=\"fade-item fade-item10\"></i>\n" +
                "                <i class=\"fade-item fade-item11\"></i>\n" +
                "                <i class=\"fade-item fade-item12\"></i>\n" +
                "            </div>\n" +
                "        </div>",
            css: {
                border: 'none',
                // padding: '15px',
                backgroundColor: 'none',
                left: '40%',
                // border:unset,
                // '-webkit-border-radius': '10px',
                // '-moz-border-radius': '10px',
                // opacity: .5,
                // color: '#fff'
            }
        });
    var latlng = map.getBounds();
    var zoom = map.getZoom();
    var lat1 = latlng['_southWest'].lat;
    var lat2 = latlng['_northEast'].lat;
    var lon1 = latlng['_southWest'].lng;
    var lon2 = latlng['_northEast'].lng;
    while (lon1 <= -180) {
        lon1 = lon1 + 360;
        lon2 = lon2 + 360;
    }
    while (lon2 >= 360) {
        lon1 = lon1 - 360;
        lon2 = lon2 - 360;
    }
    lat1 = Math.floor(lat1 / step) * step;
    lat2 = Math.floor(lat2 / step) * step;
    lon1 = Math.floor(lon1 / step) * step;
    lon2 = Math.floor(lon2 / step) * step;
    var data = {data: [{data: []}, {data: []}]};
    var json={};
    var ssh={};
    sshdata=[];
    for (var i = lat2; i >= lat1; i = i - step) {
        for (var j = lon1; j <= lon2; j = j + step) {
            var l=j;
            while(l<0)l=l+360
            if (!layerList[page + '_' + i + '_' + l]) {
                json[page + '_' + i + '_' + j]=getJSON(i, j, step)
                ssh[page + '_' + i + '_' + j]=getJSONssh(i, j, step)
            }
        }
        for (var b = 0; b < step*12; b++) {
            for (var a = lon1; a <= lon2; a = a + step) {
                for (var c = 0; c <step*12; c++) {
                    var l=a;
                    while(l<0)l=l+360
                    if(!layerList[page + '_' + i + '_' + l]||!layerList[page + '_' + i + '_' + l].uo||!layerList[page + '_' + i + '_' + l].sst){
                        await json[page + '_' + i + '_' + a];
                        await ssh[page + '_' + i + '_' + a];
                    }

                    data.data[0].data.push(layerList[page + '_' + i + '_' + l].uo[c + b * step * 12]);
                    data.data[1].data.push(layerList[page + '_' + i + '_' + l].vo[c + b * step * 12]);
                    sshdata.push([layerList[page + '_' + i + '_' + l].ssh[c + b * step * 12],layerList[page + '_' + i + '_' + l].sst[c + b * step * 12]])
                }
            }
        }

    }

    data.data[0].header = {

        "parameterUnit": "m.s-1",
        "parameterNumber": 2,
        "dx": 1 / 12,
        "dy": 1 / 12,
        "parameterNumberName": "eastward_wind",
        "la1": lat2+step,
        "la2": lat1,
        "parameterCategory": 2,
        "lo2": lon2,
        "nx": (lon2 - lon1+step) * 12,
        "ny": (lat2 - lat1+step) * 12,
        "lo1": lon1
    };
    data.data[1].header = {

        "parameterUnit": "m.s-1",
        "parameterNumber": 3,
        "dx": 1 / 12,
        "dy": 1 / 12,
        "parameterNumberName": "eastward_wind",
        "la1": lat2,
        "la2": lat1,
        "parameterCategory": 2,
        "lo2": lon2,
        "nx": (lon2 - lon1+step) * 12,
        "ny": (lat2 - lat1+step) * 12,
        "lo1": lon1
    };

    λ0 = data.data[0].header.lo1;
    φ0 = data.data[0].header.la1; // the grid's origin (e.g., 0.0E, 90.0N)

    Δλ = data.data[0].header.dx;
    Δφ = data.data[0].header.dy;
    ni = data.data[0].header.nx;
    nj = data.data[0].header.ny; // number of grid points W-E and N-S (e.g., 144 x 73)
    grid = [];
    var p = 0;
    var isContinuous = Math.floor(ni * Δλ) >= 360;

    for (var j = 0; j < nj; j++) {
        var row = [];

        for (var i = 0; i < ni; i++, p++) {
            row[i] = sshdata[p];
        }

        if (isContinuous) {
            // For wrapped grids, duplicate first column as last column to simplify interpolation logic
            row.push(row[0]);
        }
        grid[j] = row;
    }
    if (velocityLayer) {
//        map.removeLayer(velocityLayer)
        velocityLayer.setData(data.data);
    }else{
    velocityLayer = L.velocityLayer({
            displayValues: false,
            displayOptions: {
                velocityType: "Global CMEMS",
                displayPosition: "bottomleft",
                displayEmptyString: "No cmems data"
            },
            data: data.data,
            maxVelocity: 1.5,
            // lineWidth:15,
            particleMultiplier: 1 / 100,//粒子的数量

            // colorScale: ["rgb(255,255,255)","rgb(255,255,255)","rgb(255,255,255)","rgb(255,255,255)","rgb(255,255,255)"],

            // colorScale:["orange","red","purple","black"],
            // colorScale:[0xffffff, 0x7453ff, 0x1e8dff, 0x12b6ff, 0x06dfff, 0x03f2b6, 0x00eb0b, 0xb0ff33, 0xffec15, 0xffc513, 0xff672b, 0xff2ae3, 0xaf00e9],
            velocityScale: 0.2 // arbitrary default 0.005

        });
        // layerControl.addOverlay(velocityLayer, "Wind - Global");
        map.addLayer(velocityLayer)
    }
    //velocityLayer.setData(mapData);

    $.unblockUI();
}

map.on('movestart', function () {
    // if(velocityLayer){
    //     map.removeLayer(velocityLayer);
    // }
})
function formatDegree(value) {
    ///<summary>将度转换成为度分秒</summary>
    value = Math.abs(value);
    var v1 = Math.floor(value);//度
    var v2 = Math.floor((value - v1) * 60);//分
    var v3 = Math.round((value - v1) * 3600 % 60);//秒
    return v1 + '° ' + ("00" + v2).slice(-2) + '\' ' + ("00" + v3).slice(-2) + '" ';
}
var marker;
var markerLatlng;
var floorMod = function floorMod(a, n) {
    return a - n * Math.floor(a / n);
};
var isValue = function isValue(x) {
    return x !== null && x !== undefined;
};
var bilinearInterpolateVector = function bilinearInterpolateVector(x, y, g00, g10, g01, g11) {
    var rx = 1 - x;
    var ry = 1 - y;
    var a = rx * ry,
        b = x * ry,
        c = rx * y,
        d = x * y;
    var g=g00[0]>0?g00:g10[0]>0?g10:g01[0]>0?g01:g11;
    if(g00[0]===0)g00=g;
    if(g10[0]===0)g10=g;
    if(g01[0]===0)g01=g;
    if(g11[0]===0)g11=g;

    var u = g00[0] * a + g10[0] * b + g01[0] * c + g11[0] * d;
    var v = g00[1] * a + g10[1] * b + g01[1] * c + g11[1] * d;

    return [u, v];
};
var interpolate = function interpolate(λ, φ) {
    if (!grid) return null;
    var i = floorMod(λ - λ0, 360) / Δλ; // calculate longitude index in wrapped range [0, 360)
    var j = (φ0 - φ) / Δφ; // calculate latitude index in direction +90 to -90
    var fi = Math.floor(i),
        ci = fi + 1;
    var fj = Math.floor(j),
        cj = fj + 1;
    var row;

    if (row = grid[fj]) {
        var g00 = row[fi];
        var g10 = row[ci];

        if (isValue(g00) && isValue(g10) && (row = grid[cj])) {
            var g01 = row[fi];
            var g11 = row[ci];
            if (isValue(g01) && isValue(g11)) {

                // All four points found, so interpolate the value.
                return bilinearInterpolateVector(i - fi, j - fj, g00, g10, g01, g11);
            }
        }
    }

    return null;
};
function getUV(latlng) {
    if (velocityLayer != null) {
        var pos = velocityLayer._map.containerPointToLatLng(map.latLngToContainerPoint(latlng));
        var gridValue = velocityLayer._windy.interpolatePoint(pos.lng, pos.lat);
        var sshValue=interpolate(pos.lng, pos.lat);
        if (gridValue && !isNaN(gridValue[0]) && !isNaN(gridValue[1]) && gridValue[2]) {
            u = gridValue[0]
            v = gridValue[1]
            var speed = Math.round(Math.sqrt(u * u + v * v) * 10000) / 10000;
            var dir = -Math.atan2(-u, v) * 180.0 / Math.PI + 180;
            if (dir < 0) dir += 360.0;
            else if (dir >= 360) dir -= 360.0;
            dir = Math.round(dir);
            $('.dir').html(dir + "°")
            $('.speed').html(convertSpeed(speed))
            $('.arrow').show()
            $('.arrow img').css({
                "-webkit-transform": "rotate("+dir+"deg)",
                "-moz-transform": "rotate("+dir+"deg)",
                "transform": "rotate("+dir+"deg)" /* For modern browsers(CSS3)  */
            });
                $('.sst').html(Math.round(sshValue[1]*10)/10+"℃")
            if(is3d){
                $('.height').html(sshValue[0].toFixed(2)+"‰")
            }else{
                $('.height').html(convertHeight1(sshValue[0]))
            }
        } else {
            $('.arrow').hide()
            $('.dir').html(" - ")
            $('.speed').html(" - ")
            $('.sst').html(' - ')
            $('.height').html(' - ')
        }
    }
}
function moveEvent(latlng) {
    //    if (marker) marker.remove();
    //
    //    marker = L.marker(latlng, { draggable: true });
    // var geohash=encodeGeoHash(latlng.lat,latlng.lng);
    // $.getJSON('/weather/v1/getDepth',{geohash:geohash},function(ret){
    //     if(ret.code==0){
    //         $('.depth').html(ret.data.depth)
    //     }else{
    //         $('.depth').html('error')
    //     }
    // })
    var lng = latlng.lng
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    $('#lat').html((latlng.lat > 0 ? 'N ' : 'S ') + "<span style='color:orange'>" + formatDegree(latlng.lat)) + "</span>"
    $('#lon').html((lng > 0 ? 'E ' : 'W ') + "<span style='color:orange'>" + formatDegree(lng)) + "</span>"
    getUV(latlng);

}
function getDepth(lat, lng) {
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    if ($('.dir').text().trim().length > 1) {
        if (dataDomain.length > 0) {
            var geohash = encodeGeoHash(lat, lng);
            //https://dosl.yuchong.ink:7043/weather/v1/getDepth'
            $.getJSON(dataDomain + '/weather/v1/getDepth', { geohash: geohash }, function (ret) {
                if (ret.code == 0) {
                    $('.depth').html(convertHeight(ret.data.depth))
                } else {
                    $('.depth').html('error')
                }
            })
            // if(!is3d){
            //     $.getJSON(dataDomain + '/weather/v1/getCmemsSST', { geohash: geohash,h:page }, function (ret) {
            //         if (ret.code == 0) {
            //             $('.sst').html(Math.round(ret.data[1]*10)/10+"℃")
            //             $('.height').html(convertHeight1(ret.data[0]))
            //         } else {
            //             $('.sst').html(' - ')
            //             $('.height').html(' - ')
            //
            //         }
            //     })
            // }else{
            //     h=page/6;
            //
            //     $.getJSON(dataDomain + '/weather/v1/getCmems3dSST', { geohash: geohash,h:h,d:urlPrefix.match(/\d+_$/)[0].replace(/_/,'') }, function (ret) {
            //         if (ret.code == 0) {
            //             $('.sst').html(Math.round(ret.data[1]*10)/10+"℃")
            //             $('.height').html(ret.data[0].toFixed(2)+"‰")
            //         } else {
            //             $('.sst').html(' - ')
            //             $('.height').html(' - ')
            //
            //         }
            //     })
            // }
        }

    } else {
        $('.depth').html(' - ')
        $('.sst').html(' - ')
        $('.height').html(' - ')
    }
}

map.on('contextmenu', function (e) {
    // contextmenu 事件与flutter的点击事件冲突

})
map.on('click', function (e) {
    //    makeMarker(e.latlng)
})
map.on('zoomend', function (e) {

})
map.on('move', function (e) {
    moveEvent(map.getCenter());
})
map.on('moveend', function (e) {


    if (velocityLayer) {
        //velocityLayer._clearAndRestart();
//        map.removeLayer(velocityLayer)
    }

    getDepth(map.getCenter().lat, map.getCenter().lng);
    setMapData()
//    setTimeout(function () {
//        window.nativeWebView.callHandler("loadData", map.getCenter().lat, map.getCenter().lng);
//    }, 300);

    //    $('.leaflet-map-pane canvas').css('z-index', 1000)
    //    getData();

})

$('#go2Detail').bind('click', function () {
        var lat=map.getCenter().lat;
        var lon=map.getCenter().lng;
        while(lat>180){
            lat=lat-360;
        }
        while(lon>180){
            lon=lon-360;
        }
        while(lat<-180){
            lat=lat+360;
        }
        while(lon<-180){
            lon=lon+360;
        }
        window.nativeWebView.callHandler("go2Detail", lat, lon);
})
// init('https://dosl.yuchong.ink:7043','https://visdata.9oc.net/demo/cmems/data/20201009/cmems3d_0_',0,"");
// setMapData()